// count how many columns for each length, then try to pair them up for possible heights

#include <stdio.h>
#include <assert.h>
#include <algorithm>

// constraints
#define MAXL 20480

using namespace std;

// input data
int N, M, T, L, maxL, H, C;
int K[MAXL]; // how many columns for each height

int main() {
//  uncomment the following lines if you want to read/write from files
//  freopen("input.txt", "r", stdin);
//  freopen("output.txt", "w", stdout);

    assert(3 == scanf("%d %d %d", &N, &M, &T));
    for (int i=0; i<N; i++) {
        assert(1 == scanf("%d", &L));
        K[L]++; // insert new column
        maxL = max(maxL, L); // update maximum length
    }

    // for each plausible height starting from H, while i can't find M columns
    for (H = T; H <= 2*maxL and C < M; H++) {
        C = K[H]; // K[H] columns are readily available
        // for each longer column of a pair which may exist
        for (int i=H/2+1; i<H and i<=maxL; i++)
            C += min(K[i], K[H-i]); // count pairs
        // if H even, pair up columns of size H/2
        if (H%2 == 0) C += K[H/2]/2;
    }
    if (C < M) printf("IMPOSSIBLE\n"); // M columns not found
    else printf("%d\n", H-1); // columns found (but H incremented in cycle)
    return 0;
}
