// For every student which hasn't a pen, tries to take one from their left
// and their right, respectively.
 
#include <iostream>
#include <algorithm>

using namespace std;

const int MAXN = 1000000;
int N, pens[MAXN];

int main() {
    cin >> N;
    for (int i = 0; i < N; i++)
        cin >> pens[i];

    // The first student can ask only to their right.
    if (pens[0] == 0)
        if (pens[1] > 1) {
            pens[1]--;
            pens[0]++;
        }
    
    // Every student in the "middle" can ask both to their left and right,
    // if necessary. 
    for (int i = 1; i < N - 1; i++) {
        if (pens[i] == 0) {
            // i asks to i-1
            if (pens[i - 1] > 1) {
                pens[i - 1]--;
                pens[i]++;
            }
        }
        if (pens[i] == 0) {
            // i asks to i+1
            if (pens[i + 1] > 1) {
                pens[i + 1]--;
                pens[i]++;
            }
        }
    }

    // The last student can ask only to their left.
    if (pens[N - 1] == 0)
        if (pens[N - 2] > 1) {
            pens[N - 2]--;
            pens[N - 1]++;
        }

    cout << count_if(pens, pens + N, [](int x){ return x == 0; }) << endl;
}

